package Test;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 *
 * User: hf
 * Date: 21.09.2003
 * Time: 16:09:04
 *
 */
public class SimulationWindow extends JFrame implements ActionListener{

    private JButton init = new JButton("Init");
    private JButton start = new JButton("Start");
    private JButton stop = new JButton("Stop");
    private Choice anzahl = new Choice();
    private TestServer server = new TestServer();
    private GameGrid gameGrid;
    private JPanel menu;

    public SimulationWindow(){

        addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
        });

        setTitle("Agenten-Wettrennen");
        setSize(300, 500);
        setLocation(100,100);
         for (int i = 1; i < 4; i++){
             anzahl.addItem(""+i);
         }


        menu = new JPanel();
        start.addActionListener(this);
        stop.addActionListener(this);
        init.addActionListener(this);
        menu.add(anzahl);
        menu.add(init);
        menu.add(start);

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(menu, BorderLayout.SOUTH);

    }

    public void actionPerformed(ActionEvent e) {

        if (e.getSource().equals(init)){
            int zahl = anzahl.getSelectedIndex() + 1;
            System.out.println(zahl);
            try{
            server.unregisterAllAgents();
            } catch (Exception ex){
                // do nothing
            }
            for (int i = 0; i < zahl ; i++){
                server.registerAgent(new TestAgent(i, server));
            }
            gameGrid = new GameGrid(server);

            server.setSim(this);
            getContentPane().add(gameGrid, BorderLayout.CENTER);
            setVisible(true);



        }   if (e.getSource().equals(start)){


            try{
                menu.setVisible(false);
                remove(menu);
                menu = new JPanel();
                menu.add(stop);
                getContentPane().add(menu, BorderLayout.SOUTH);
                menu.setVisible(true);
                server.startSimulation();
            } catch (NullPointerException ex){

                    int zahl = anzahl.getSelectedIndex() + 1;
                    System.out.println(zahl);
                    try{
                    server.unregisterAllAgents();
                    } catch (Exception ex1){
                        // do nothing
                    }
                    for (int i = 0; i < zahl ; i++){
                        server.registerAgent(new TestAgent(i, server));
                    }
                    gameGrid = new GameGrid(server);

                    server.setSim(this);
                    getContentPane().add(gameGrid, BorderLayout.CENTER);
                    setVisible(true);
                    menu.setVisible(false);
                    remove(menu);
                    menu = new JPanel();
                    menu.add(stop);
                    getContentPane().add(menu, BorderLayout.SOUTH);
                    menu.setVisible(true);
                    server.startSimulation();

            }
        }

        else if (e.getSource().equals(stop)){
            server.unregisterAllAgents();
            System.out.println("STOOOOOOOOP!!!!!");
            System.exit(0);
        }
    }


    public synchronized void update(){
        gameGrid.repaint();
    }


    class GameGrid extends JPanel{

        private TestServer server;

        public GameGrid(TestServer s){
            this.server = s;
        }

        protected void paintChildren(Graphics g) {

            int[][] positions = server.getAgentPositions();
            for(int i = 0; i < positions.length; i++){
                System.out.println("Positions received: " + (i+1) + "X: " + positions[i][0] + " Y: "+ positions[i][1]);
            }

            for (int i =0; i < 500; i+=20){
                g.drawLine(0, i, 300, i);
            }
            for (int j = 0; j <290; j+=20){
                g.drawLine(j, 0, j, 500);
            }

            g.fillRect(0, 40, 305, 5);
            g.drawString("Start", 20, 35);

            g.fillRect(0, 400, 305, 5);
            g.drawString("Ziel", 20, 395);


            for(int i = 0; i < positions.length; i++){
                g.drawString(""+ (i+1), positions[i][0], positions[i][1]);
            }
        }
    } // Ende Inner Class
}
