package Test;

import java.util.Random;

/**
 *
 * User: hf
 * Date: 21.09.2003
 * Time: 14:55:48
 */
public class TestAgent extends Thread{

    public static final int NO_MOVE = 0;
    public static final int MOVE_NORTH = 1;
    public static final int MOVE_WEST = 2;
    public static final int MOVE_SOUTH = 3;
    public static final int MOVE_EAST = 4;

    private Random r;
    private TestServer server;
    private int id;

    // Konstruktor
    public TestAgent(int id,TestServer server){
        this.server = server;
        this.id = id;
        r = new Random((long) id % (id*13 + 17)*5479);
    }


    public void run() {
        while (true){

            int nextmove = this.calculateMove();
            sendMove(nextmove);

            try {
                Thread.sleep(Math.round(r.nextFloat()* 2000));
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }
    }


    public synchronized int calculateMove(){
        int move = NO_MOVE;
        float f = r.nextFloat();
        log(""+f);

        if ( f < 0.1){
            move = MOVE_NORTH;
            log("Next Move: North");
        }
        else if (0.1 <= f && f < 0.2) {
            move = MOVE_WEST;
            log("Next Move: West");
        }
        else if (0.2 <= f && f < 0.3) {
            move = MOVE_EAST;
            log("Next Move: EAST");
        }
        else if (0.3 <= f && f < 0.8) {
            move = MOVE_SOUTH;
            log("Next Move: South");
        }
        else {log("Next Move: NO MOVE");} // do nothing, NO_MOVE

        return move;
    }



    public synchronized void sendMove(int moveorder){
        server.receiveMoveOrder(this.id, moveorder);
    }

     private void log(String msg){
        System.out.println("\n" + this.getClass().toString() + ", " + this.getName() + ": " + msg);


    }

    public int getId() {
        return id;
    }
}
