package editor;

import java.awt.*;
import java.awt.event.*;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.*;
/**
 * Dies ist die Startklasse, die die Anfangsgui startet
 */
public class Editor
    extends Frame
    implements ActionListener {

  Sql db;
  static int umgebungid;
  /**
   * Setzen der aktuellen Umgebung
   * @param id id der zu sentzenden Umgebung
   */
  public static void setumgebung(int id){
    umgebungid=id;
  }
  /**
   * Abfragen welche Umgebung gerade aktuell ist
   * @return  id id der aktuellen Umgebung
   */
  public static int getumgebung(){
    return umgebungid;
  }

  class Action
      implements ActionListener {

    public void actionPerformed(ActionEvent e) {

    }
  }

  /**
   * Konstruktor, welcher das Hauptfenster erstellt
   */

  public Editor() {
    super("MAMiSuSi 0.7 Beta");

    db = new Sql();

    // Men erstellen
    MenuBar mbar = new MenuBar();
    Menu menu1 = new Menu("Datei");
    MenuItem menu1a = new MenuItem("Simulation starten");
    MenuItem menu1c = new MenuItem("Schlieen");
    Menu menu2 = new Menu("Elemente");

    MenuItem menu2b = new MenuItem("Sensor anlegen");
    MenuItem menu2c = new MenuItem("Antrieb anlegen");
    MenuItem menu2d = new MenuItem("Roboter anlegen");
    MenuItem menu2e = new MenuItem("Gelndetyp anlegen");
    MenuItem menu2f = new MenuItem("Mine anlegen");
    MenuItem menu2g = new MenuItem("Element ndern");
    MenuItem menu2h = new MenuItem("Element lschen");

    Menu menu3 = new Menu("Spielfeld");
    MenuItem menu3a = new MenuItem("Spielfeld anlegen");
    MenuItem menu3b = new MenuItem("Spielfeld ndern");

    Menu menu4 = new Menu("?");
    MenuItem menu4a = new MenuItem("Hilfe");

    Menu menu5 = new Menu("Umgebung");
    MenuItem menu5a = new MenuItem("Umgebung anlegen");
    MenuItem menu5b = new MenuItem("Umgebung auswhlen");
    MenuItem menu5c = new MenuItem("Umgebung ndern");
    MenuItem menu5d = new MenuItem("Umgebung lschen");

    menu1a.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Simstartgui startgui = new Simstartgui();
        removeAll();
        add(startgui);
        setVisible(false);
        setVisible(true);
      }
    }
    );

    menu1c.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        db.close();
        System.exit(0);
      }
    });

    menu2b.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Sensorgui g = new Sensorgui();
      }
    }
    );
    menu2c.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Antriebgui g = new Antriebgui();
      }
    }
    );
    menu2d.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Robotergui g = new Robotergui();
      }
    }
    );
    menu2e.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Gelaendegui g = new Gelaendegui();
      }
    }

    );
    menu2f.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Minengui g = new Minengui();
      }
    }
    );
    menu2g.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Datenaendern g = new Datenaendern();
      }
    }
    );
    menu2h.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Datenloeschen g = new Datenloeschen();
      }
    }
    );


    menu3a.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Spielfeldguia s = new Spielfeldguia();
        removeAll();
        add(s);
        setVisible(false);
        setVisible(true);

      }
    }
    );
    menu3b.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Spielfeldandern g = new Spielfeldandern();
        removeAll();
        add(g);
        setVisible(false);
        setVisible(true);

      }
    }
    );

    menu4a.addActionListener(this);

    menu5a.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Umgebunganlegengui u = new Umgebunganlegengui();
      }
    }

    );
menu5b.addActionListener(new Action() {
  public void actionPerformed(ActionEvent e) {
    Umgebungsetzengui u = new Umgebungsetzengui();
  }
}
);
    menu5c.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Umgebunganlegengui u = new Umgebunganlegengui(true);
      }
    }
);
    menu5d.addActionListener(new Action() {
      public void actionPerformed(ActionEvent e) {
        Umgebungloeschengui u = new Umgebungloeschengui();
      }
    }
);

    menu1.add(menu1a);
    menu1.add(menu1c);

    menu2.add(menu2b);
    menu2.add(menu2c);
    menu2.add(menu2d);
    menu2.add(menu2e);
    menu2.add(menu2f);
    menu2.add(menu2g);
    menu2.add(menu2h);

    menu3.add(menu3a);
    menu3.add(menu3b);

    menu4.add(menu4a);

    menu5.add(menu5a);
    menu5.add(menu5b);
    menu5.add(menu5c);
    menu5.add(menu5d);

    mbar.add(menu1);
    mbar.add(menu2);
    mbar.add(menu3);
    mbar.add(menu5);
    mbar.add(menu4);
    setMenuBar(mbar);
    //Ende Men

    Titelbild t = new Titelbild();
    add(t);

    setSize(Toolkit.getDefaultToolkit().getScreenSize());
    show();
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        db.close();
        System.exit(0);
      }
    });
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    // Setzen der aktiven Umgebung auf die Umgebung, welche beim letzten mal aktiv war
    ResultSet result=db.select("select uid from umgebung where aktiv = 'true'");
    try {
      result.next();
      umgebungid=result.getInt("uid");
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

  }


  public void actionPerformed(ActionEvent e) {
    System.out.println(e);
    System.out.println(e.getActionCommand());
  }

  public static void main(String args[]) {
    Editor ed = new Editor();

  }

  private void jbInit() throws Exception {
    this.setBackground(SystemColor.menu);
  }
}
