package mailbox;

/**
 *
 * User: Standard
 * Date: 26.10.2003
 * Time: 15:15:05
 *
 */
public class Message {


    // Konstanten fr die Drehrichtung
    public static final int TURNNORTH = 1;
    public static final int TURNNORTHEAST = 2;
    public final static int TURNEAST = 3;
    public final static int TURNSOUTHEAST = 4;
    public final static int TURNSOUTH = 5;
    public final static int TURNSOUTHWEST = 6;
    public final static int TURNWEST = 7;
    public final static int TURNNORTHWEST = 8;

    // Konstanten fr die Bewegung
    public final static int MOVEFORWARD = 9;
    public final static int MOVEBACKWARD = 10;



    // Konstanten fr die Betreffe
    // AGENT REQUESTS **************************************
    public final static int SCAN = 103;
    public final static int GETENERGY = 104;
    public final static int GETINFO = 105;
	public final static int	REMOVEMINE = 106;


    // SERVERRESPONSES *************************************
    // Einfache Meldungen
    public final static int SCANRESULT = 800;
    public final static int MOVEFINISHED = 801;
    public final static int INFO = 802;
    public final static int MINEREMOVED = 803;
    public final static int REMAININGENERGY = 804;

    // Fehlercodes
    public final static int ERR_NOTSUPPORTED = 904;
    public final static int ERR_ALREADYMOVING = 905;
    public final static int ERR_ALREADYSCANNING = 906;
    public final static int ERR_ALREADYREMOVING = 907;
    public final static int ERR_AGENT_UNKOWN = 908;


    public final static int SYSTEMMESSAGE = 998;
    public final static int PING = 999;

    public static final String SERVER = "GameServer";
    public static final String MAILBOXSYSTEM = "mailboxsystem";





    protected String absender;
    protected String empfaenger;
    protected int betreff;
    protected Object content;
    // Empfnger wird in der spezifischen Methode des Mailboxsystems implementiert


    public Message(){}

    public Message(int betreff, Object content){
        this.betreff = betreff;
        this.content = content;
    }

    public Message(int betreff){
        this.betreff = betreff;
    }

    public Message(String absender, int betreff, Object content) {
        this.absender = absender;
        this.betreff = betreff;
        this.content = content;
    }

    public Message(String absender, String empfaenger, int betreff, Object content ) {
        this.absender = absender;
        this.betreff = betreff;
        this.content = content;
        this.empfaenger = empfaenger;
    }


    public String getAbsender() {
        return absender;
    }

    public void setAbsender(String absender) {
        this.absender = absender;
    }

    public String getEmpfaenger() {
        return empfaenger;
    }

    public void setEmpfaenger(String empfaenger) {
        this.empfaenger = empfaenger;
    }

    public int getBetreff() {
        return betreff;
    }

    public void setBetreff(int betreff) {
        this.betreff = betreff;
    }

    public Object getContent() {
        return content;
    }

    public void setContent(Object content) {
        this.content = content;
    }

    public String toString() {
        return ("Message " + "Absender: " + absender + ", " + "Betreff: " + betreff + "Content:" + content);
    }

    public static String resolveBetreff(int betreff){
        String ret = "unbekannt";
        switch (betreff){
            case TURNNORTH:        ret = "TURNNORTH"; break;
            case TURNNORTHEAST:    ret ="TURNNORTHEAST"; break;
            case TURNEAST:         ret = "TURNEAST"; break;
            case TURNSOUTHEAST:   ret = "TURNSOUTHEAST"; break;
            case TURNSOUTH: ret = "TURNSOUTH"; break;
            case TURNSOUTHWEST : ret =  "TURNSOUTHWEST"; break;
            case TURNWEST : ret =  "TURNWEST"; break;
            case TURNNORTHWEST : ret =  "TURNNORTHWEST"; break;
            case MOVEFORWARD : ret =  "MOVEFORWARD"; break;
            case MOVEBACKWARD : ret =  "MOVEBACKWARD"; break;
            case SCAN : ret =  "SCAN"; break;
            case GETENERGY : ret =  "GETENERGY"; break;
            case GETINFO : ret =  "GETINFO"; break;
            case SCANRESULT : ret =  "SCANRESULT"; break;
            case MOVEFINISHED : ret =  "MOVEFINISHED"; break;
            case INFO : ret =  "INFO"; break;
            case ERR_NOTSUPPORTED : ret =  "ERR_NOTSUPPORTED"; break;
            case ERR_ALREADYMOVING : ret =  "ERR_ALREADYMOVING"; break;
            case ERR_AGENT_UNKOWN : ret =  "ERR_AGENT_UNKOWN"; break;
            case MINEREMOVED: ret  = "MINEREMOVED"; break;
            case REMOVEMINE: ret = "REMOVEMINE";  break;
            case  SYSTEMMESSAGE: ret = "SYSTEMMESSAGE"; break;
            case  PING : ret =  "PING"; break;
            case ERR_ALREADYSCANNING: ret = "ERR_ALREADYSCANNING";break;
            case ERR_ALREADYREMOVING: ret = "ERR_ALREADYREMOVING";  break;
            case REMAININGENERGY: ret = "REMAININGENERGY"; break;

        }

        return ret;
    }

}
